﻿using Microsoft.Win32;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication1
{
    class JPKInterface
    {
        public delegate void ProgressProc(IntPtr SessionID,
                long FilesCount, long CurrentFile, long FileSize, long CurrentPosition,
                ref int UserBreak, int Err, [In, MarshalAs(UnmanagedType.LPWStr)]String ErrMsg);

        public delegate void FinishProc(IntPtr SessionID,
            [In, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumber, int Status,
            [In, MarshalAs(UnmanagedType.LPWStr)]String StatusText, [In, MarshalAs(UnmanagedType.LPWStr)]String UPO,
            int UserBreak, int Err, [In, MarshalAs(UnmanagedType.LPWStr)]String ErrMsg);


        public delegate void TSetLic([In, MarshalAs(UnmanagedType.LPWStr)]String licText);
        public delegate void TSetPublicKeyFile([In, MarshalAs(UnmanagedType.LPWStr)]String KeyFileName, [In, MarshalAs(UnmanagedType.LPWStr)]String KeyPass);
        public delegate void TSetCertFile([In, MarshalAs(UnmanagedType.LPWStr)]String CertFileNameOdIndex, [In, MarshalAs(UnmanagedType.LPWStr)]String CertPass);
        public delegate int TGetCertCurrentIndex();
        public delegate int TShowCertList(uint ParentHandle);
        public delegate void TSetPublicKey(IntPtr Key, int KeySize, [In, MarshalAs(UnmanagedType.LPWStr)]String KeyPass);
        public delegate void TSetCert(IntPtr Cert, int CertSize, [In, MarshalAs(UnmanagedType.LPWStr)]String CertPass);
        public delegate int TSetProgressCaption(IntPtr SessionID, [In, MarshalAs(UnmanagedType.LPWStr)]String Caption);
        public delegate void TSetParentwindowHandle(uint Handle);
        public delegate void TInternetSettingsForm(uint ParentHandle);
        public delegate int TGetCertyficateCount();
        public delegate int TGetCertyficate(int Index, [Out, MarshalAs(UnmanagedType.LPWStr)]String cert);
        public delegate int TAddXMLJPK([MarshalAs(UnmanagedType.LPStr)]String XML, byte DocType, [MarshalAs(UnmanagedType.LPWStr)]String DefFileName);
        public delegate int TAddXMLJPKFile([In, MarshalAs(UnmanagedType.LPWStr)]String XMLFileName, byte DocType);
        public delegate IntPtr TSignSendJPK(int TestMode, ProgressProc Progress, FinishProc Finish, int SyncFinish);
        public delegate int TSignSendJPKAndWait(int TestMode, ProgressProc Progress, [Out, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumbers);
        public delegate void TSignSendBreak(IntPtr SessionID);
        public delegate void TWaitForEnd(IntPtr SessionID, [Out, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumbers);
        public delegate String TGetReferenceNumbers([In, MarshalAs(UnmanagedType.LPWStr)]String SessionID);
        public delegate int TGetUPO(int TestMode, [In, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumber, [Out, MarshalAs(UnmanagedType.LPWStr)]String UPO, out int Status, [Out, MarshalAs(UnmanagedType.LPWStr)]String statusText);
        public delegate int TBreakGetUPO([In, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumber);
        public delegate void TJPKGetLastError([Out, MarshalAs(UnmanagedType.LPWStr)]String ErrText);
        public delegate int TFileNameValidate([In, MarshalAs(UnmanagedType.LPWStr)]String FileName, [Out, MarshalAs(UnmanagedType.LPWStr)]String ErrText);
        public delegate int TXMLValidate([MarshalAs(UnmanagedType.LPStr)]String FileName, [Out, MarshalAs(UnmanagedType.LPWStr)]String errText);
        public delegate void TXMLValidateBreak();
        public delegate void TPrintUPO([In, MarshalAs(UnmanagedType.LPWStr)]String UPO, uint ParentHandle);
        public delegate void TFinalizeDLL();


        [DllImport("kernel32.dll", CallingConvention = CallingConvention.Winapi)]
        static extern IntPtr LoadLibrary(string lpFileName);

        [DllImport("kernel32.dll", CallingConvention = CallingConvention.Winapi)]
        static extern bool FreeLibrary(IntPtr hModule);

        [DllImport("kernel32.dll", CallingConvention = CallingConvention.Winapi)]
        static extern IntPtr GetProcAddress(IntPtr hModule, string lpProcName);

        public static TSetLic SetLic = null;
        public static TSetPublicKeyFile SetPublicKeyFile = null;
        public static TSetCertFile SetCertFile = null;
        public static TGetCertCurrentIndex GetCertCurrentIndex = null;
        public static TShowCertList ShowCertList = null;
        public static TSetPublicKey SetPublicKey = null;
        public static TSetCert SetCert = null;
        public static TSetProgressCaption SetProgressCaption = null;
        public static TSetParentwindowHandle SetParentwindowHandle = null;
        public static TInternetSettingsForm InternetSettingsForm = null;
        public static TGetCertyficateCount GetCertyficateCount = null;
        public static TGetCertyficate GetCertyficate = null;
        public static TAddXMLJPK AddXMLJPK = null;
        public static TAddXMLJPKFile AddXMLJPKFile = null;
        public static TSignSendJPK SignSendJPK = null;
        public static TSignSendJPKAndWait SignSendJPKAndWait = null;
        public static TSignSendBreak SignSendBreak = null;
        public static TWaitForEnd WaitForEnd = null;
        public static TGetReferenceNumbers GetReferenceNumbers = null;
        public static TGetUPO GetUPO = null;
        public static TBreakGetUPO BreakGetUPO = null;
        public static TJPKGetLastError JPKGetLastError = null;
        public static TFileNameValidate FileNameValidate = null;
        public static TXMLValidate XMLValidate = null;
        public static TXMLValidateBreak XMLValidateBreak = null;
        public static TPrintUPO PrintUPO = null;
        public static TFinalizeDLL FinalizeDLL = null;

        static String JPKLibDLLName = "JPKLibUI.dll";
        static String cRegJPK = "Software\\IPSPI\\JotPeK";
        static String cRegJPKPathKeyName = "Path";
        static String JPKDLLFullPath = "";
        static IntPtr vJPKLib;

        static void InitJPKDLL()
        {
            if (JPKDLLFullPath.Length == 0)
                JPKDLLFullPath = AppDomain.CurrentDomain.BaseDirectory + JPKLibDLLName;
            else
            {
                try
                {
                    using (RegistryKey key = Registry.LocalMachine.OpenSubKey(cRegJPK))
                    {
                        if (key != null)
                        {
                            Object o = key.GetValue(cRegJPKPathKeyName);
                            if (o != null)
                            {
                                JPKDLLFullPath = o.ToString();
                                if (JPKDLLFullPath.EndsWith("\\"))
                                    JPKDLLFullPath += JPKLibDLLName;
                                else
                                    JPKDLLFullPath += "\\" + JPKLibDLLName;
                            }
                        }
                    }
                }
                catch (Exception ex)
                {
                }
            }

            vJPKLib = LoadLibrary(JPKDLLFullPath);
            if (vJPKLib != IntPtr.Zero)
            {
                SetLic = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetLic"), typeof(TSetLic)) as TSetLic;
                SetPublicKeyFile = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetPublicKeyFile"), typeof(TSetPublicKeyFile)) as TSetPublicKeyFile;
                SetCertFile = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetCertFile"), typeof(TSetCertFile)) as TSetCertFile;
                GetCertCurrentIndex = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "GetCertCurrentIndex"), typeof(TGetCertCurrentIndex)) as TGetCertCurrentIndex;
                ShowCertList = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "ShowCertList"), typeof(TShowCertList)) as TShowCertList;
                SetPublicKey = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetPublicKey"), typeof(TSetPublicKey)) as TSetPublicKey;
                SetCert = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetCert"), typeof(TSetCert)) as TSetCert;
                SetProgressCaption = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetProgressCaption"), typeof(TSetProgressCaption)) as TSetProgressCaption;
                SetParentwindowHandle = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SetParentwindowHandle"), typeof(TSetParentwindowHandle)) as TSetParentwindowHandle;
                InternetSettingsForm = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "InternetSettingsForm"), typeof(TInternetSettingsForm)) as TInternetSettingsForm;
                GetCertyficateCount = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "GetCertyficateCount"), typeof(TGetCertyficateCount)) as TGetCertyficateCount;
                GetCertyficate = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "GetCertyficate"), typeof(TGetCertyficate)) as TGetCertyficate;
                AddXMLJPK = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "AddXMLJPK"), typeof(TAddXMLJPK)) as TAddXMLJPK;
                AddXMLJPKFile = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "AddXMLJPKFile"), typeof(TAddXMLJPKFile)) as TAddXMLJPKFile;
                SignSendJPK = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SignSendJPK"), typeof(TSignSendJPK)) as TSignSendJPK;
                SignSendJPKAndWait = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SignSendJPKAndWait"), typeof(TSignSendJPKAndWait)) as TSignSendJPKAndWait;
                SignSendBreak = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "SignSendBreak"), typeof(TSignSendBreak)) as TSignSendBreak;
                WaitForEnd = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "WaitForEnd"), typeof(TWaitForEnd)) as TWaitForEnd;
                GetReferenceNumbers = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "GetReferenceNumbers"), typeof(TGetReferenceNumbers)) as TGetReferenceNumbers;
                GetUPO = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "GetUPO"), typeof(TGetUPO)) as TGetUPO;
                BreakGetUPO = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "BreakGetUPO"), typeof(TBreakGetUPO)) as TBreakGetUPO;
                JPKGetLastError = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "JPKGetLastError"), typeof(TJPKGetLastError)) as TJPKGetLastError;
                FileNameValidate = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "FileNameValidate"), typeof(TFileNameValidate)) as TFileNameValidate;
                XMLValidate = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "XMLValidate"), typeof(TXMLValidate)) as TXMLValidate;
                XMLValidateBreak = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "XMLValidateBreak"), typeof(TXMLValidateBreak)) as TXMLValidateBreak;
                PrintUPO = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "PrintUPO"), typeof(TPrintUPO)) as TPrintUPO;
                FinalizeDLL = Marshal.GetDelegateForFunctionPointer(GetProcAddress(vJPKLib, "FinalizeDLL"), typeof(TFinalizeDLL)) as TFinalizeDLL;
            }
        }
    }
}
