﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Text;

namespace CSharpSample
{
    class JPKInterface
    {
        public delegate void ProgressProc(IntPtr SessionID,
                long FilesCount, long CurrentFile, long FileSize, long  CurrentPosition,
                ref int UserBreak, int Err, [In, MarshalAs(UnmanagedType.LPWStr)]String ErrMsg);

        public delegate void FinishProc(IntPtr SessionID,
            [In, MarshalAs(UnmanagedType.LPWStr)]String ReferenceNumber, int Status,
            [In, MarshalAs(UnmanagedType.LPWStr)]String StatusText, [In, MarshalAs(UnmanagedType.LPWStr)]String UPO,
            int UserBreak, int Err, [In, MarshalAs(UnmanagedType.LPWStr)]String ErrMsg);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetLic(String licText);

       
        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetPublicKeyFile(String KeyFileName, String KeyPass);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetCertFile(String CertFileNameOdIndex, String CertPass);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int GetCertCurrentIndex();

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int ShowCertList(uint ParentHandle);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetPublicKey(IntPtr Key, int KeySize, String KeyPass);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetCert(IntPtr Cert, int CertSize, String CertPass);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int SetProgressCaption(IntPtr SessionID, String Caption);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SetParentwindowHandle(uint Handle);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void InternetSettingsForm(uint ParentHandle);


        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int GetCertyficateCount();

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int GetCertyficate(int Index, out String cert);


        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern int AddXMLJPK([MarshalAs(UnmanagedType.LPStr)]String XML, byte DocType, [MarshalAs(UnmanagedType.LPWStr)]String DefFileName);


        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Ansi)]
        public static extern int AddXMLJPKFile(String XMLFileName, byte DocType);

        
        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern IntPtr SignSendJPK(int TestMode, ProgressProc Progress, FinishProc Finish, int SyncFinish);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int SignSendJPKAndWait(int TestMode, ProgressProc Progress, out String ReferenceNumbers);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void SignSendBreak(IntPtr SessionID);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void WaitForEnd(IntPtr SessionID, out String ReferenceNumbers);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern String GetReferenceNumbers(String SessionID);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int GetUPO(int TestMode, String ReferenceNumber, out String UPO, out int Status, out String statusText);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int BreakGetUPO(String ReferenceNumber);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void JPKGetLastError(out String ErrText);


        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int FileNameValidate(String FileName, out String ErrText);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern int XMLValidate([MarshalAs(UnmanagedType.LPStr)]String XMLData, out String errText);

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void XMLValidateBreak();

        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void PrintUPO(String UPO, uint ParentHandle);
       
        [DllImport("JPKLibUI.dll", CallingConvention = CallingConvention.StdCall, CharSet = CharSet.Unicode)]
        public static extern void FinalizeDLL();
       

    }
}
